/*
 * @author Lenidas de Oliveira Brando
 * 
 * Exemplo didtico para introduo  "programao orientada a objetos" (na linguagem Java)
 * Constri aleatoriamente um vetor e lista na tela
 *
 * Oredena.java -> Desenha.java
 *
 */

import java.awt.*;
import java.applet.Applet;

public class Desenha extends Canvas {

 final static int Dx = 2;
 final static int base_X = 2;
 final static int base_Y = 2;

 final static Color corFundo = new Color( 30, 100, 180); // cor das barras usuais
 final static Color corGeral = new Color(255, 255,   0); // cor das barras usuais
 final static Color corTroca = new Color(150, 150,   0); // cor das barras que sero trocadas

 int tam_Vetor     = 20;
 double max_double = 20;

 int Vetor[];
 int pos1 = 0, pos2 = 0;

 boolean lista_Vetor = true;

 Applet applet;

 public void pos( int i, int j ){
     pos1 = i;
     pos2 = j;
 }

 public Desenha (Applet ap) {
     int i;
     String imprime = "";
     Vetor = new int [tam_Vetor];
     this.applet = ap;
     for (i=0; i<tam_Vetor; i++) {
	 Vetor[i] = (int)(max_double*Math.random())%tam_Vetor;
	 if (lista_Vetor) imprime = new String(imprime+" "+Vetor[i]);
     }
     if (lista_Vetor) System.out.println( imprime );
 }

 public void vetor ( int v[] ) {
     Vetor = v;
     pos(0,0);
 }

 public Desenha (Applet ap,  int v[]) {
     int i;
     String imprime = "";
     this.tam_Vetor = v.length;
     this.applet = ap;
     Vetor = new int [ tam_Vetor ]; // v.length nmero de elementos no vetor v[]

     vetor( v );

     if (lista_Vetor) {
        for (i=0; i<tam_Vetor; i++)
            imprime = new String(imprime+" "+Vetor[i]);
        System.out.println( imprime );
     }
 }

 // Desenha no canvas
 // Sistema de coordenadas: drawRect(x1,y1, dx,dy)
 //         base_X   x1                        x1+dx
 //  base_Y +--------+-------------------------+-----+
 //         |                                        |
 //         |        |                         |     |
 //         |     ---+-------------------------+---- | y1
 //         |        |                         |     |
 //         |        |                         |     |
 //         |        |                         |     |
 //         |     ---+-------------------------+---- | y1+dy
 //         |        |                         |     |
 //         |                                        |
 //         +----------------------------------------+
 //
 public synchronized void paint(Graphics g) {
     int x = base_X+2, y = getSize().height,
         i; 
     int Dx = getSize().width / tam_Vetor - 2; // determina a largura de cada retngulo de modo a preencher a janela
     Dimension d = getSize();

     g.setColor( corFundo );      // cor das barras usuais
     g.fillRect(0, 0, d.width, d.height); // limpa a imagem toda
     g.setColor( corGeral ); // Color.yellow

     for (i=0; i<tam_Vetor; i++) {
         if (i==pos1 || i==pos2) {
            g.setColor( corTroca );
	    g.fillRect( x,y-Vetor[i] - 1, Dx,y ); // +1 garante um altura no nula para 0
            g.setColor( corGeral );
         }
         else 
 	    g.fillRect( x,y-Vetor[i] - 1, Dx,y ); // +1 garante um altura no nula para 0
	 x += Dx+2;
     }

     g.setColor(Color.red); // desenha uma linha vermelha para separar o pedao j ordenado
     g.fillRect( base_X+1+(pos1+1)*(Dx+2),y-d.height-1, 2, y);

 }

 // Chamado sempre que precisa atualizar desenho
 public void pinta() {
     repaint(); // tenta pintar tudo
 }
   
}
